Subject: Re: [apps-discuss] Fwd: I-D Action:draft-saintandre-xdash-considered-harmful-01.txt

From: Kurt Zeilenga <[email-masked]>
Date: Tue, 2 Nov 2010 20:56:30 -0700

This is completely counter to BCP 82 which argues that "Assigning Experimental and Testing Numbers Considered Useful" [published 2004], and BCP 26 [published 2008].  Has our operational experience in the last few years been so different than that the previous decades that consensus shifted 180 degrees?  

I generally oppose publication of this I-D as a BCP and give +1 to Nathaniel's comments.

(If consensus has shifted 180 degrees, this I-D really ought to obsolete BCP 82 and update BCP 26.)

-- Kurt

---

From: Dave CROCKER <[email-masked]>
Date: Tue, 02 Nov 2010 21:10:04 -0700

On 11/2/2010 8:56 PM, Kurt Zeilenga wrote:
> Has our operational experience in the last few years been so different than
> that the previous decades that consensus shifted 180 degrees?

X- was first introduced as a construct in RFC 822 in 1982.

It was dropped as a construct in the revision, RFC 2822, in 2001.

That's longer than "last few years".

The construct actually /impedes/ standardization.

It was a clever idea.  It turned out to be misguided.

d/
-- 

   Dave Crocker
   Brandenburg InternetWorking
   bbiw.net

---

From: Claudio Allocchio <[email-masked]>
Date: Wed, 3 Nov 2010 13:06:35 +0100 (CET)

> The construct actually /impedes/ standardization.

we can provide a collection of X-stuff doing the same thing... with 
different names and syntax... thus it has turned into a problem. At least 
some guidance to track it back from wilderness is needed.

> It was a clever idea.  It turned out to be misguided.

I'd say: not enough monitored...

> _______________________________________________
> apps-discuss mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/apps-discuss
>

------------------------------------------------------------------------------
Claudio Allocchio             G   A   R   R          [email-masked]
                         Senior Technical Officer
tel: +39 040 3758523      Italian Academic and       G=Claudio; S=Allocchio;
fax: +39 040 3758565        Research Network         P=garr; A=garr; C=it;

            PGP Key: http://www.cert.garr.it/PGP/keys.php3#ca

---

From: Kurt Zeilenga <[email-masked]>
Date: Wed, 3 Nov 2010 06:20:57 -0700

> That's longer than "last few years".

A few years since we last approved BCP 26.

---

From: Royer Software and Services <[email-masked]>
Date: Wed, 03 Nov 2010 08:56:38 -0600

Stop producing 'X-' == good idea.

There was an annoyingly long X- debate on calsch years ago.

The problem there was vendors hijacking the protocol with tons of their 
vendor specific extensions such
that it was difficult to have real interoperability.

Another problem was when vendors used their extensions to alter the flow 
or meaning of the data. With their
application it works just fine, with their competitors, it would 
sometimes work depending on the rest of the data.
So calsch said that those not approved by the working group, are 
considered experimental and must start
with X- .

A registration process with some additional instructions would have 
solved the problem. I can see in the future
it would be written as, those extensions not approved by the working 
groups must be registered vendor specific
and must not alter the flow or meaning of the data.

--

Doug - Royer Software and Services
http://Project-Contracting.com
(208) 806-1358 / (714) 989-6135

---

From: Keith Moore <[email-masked]>
Date: Sat, 13 Nov 2010 12:40:49 -0500

SIgh.

I'm really tired of one-sided arguments about X-.

X- is useful.  It's especially useful when you're defining something that you fully expect to be of limited use.  The last thing we need is for random implementors to be choosing keywords at random and (implicitly) expecting others to not chose the same keywords.

Sure, there are cases where something that was named with X- ends up being a de facto standard.  In those cases it should be okay to document that use, or even standardize it.  But there are also far too many cases when some vendor picks a keyword not beginning with X- and defines the associated semantics so haphazardly (if indeed the behavior is actually defined anywhere) that it should never be standardized.  

I am currently working on a project where one of the vendors insists on using URNs to name things that don't have registered namespaces, and without establishing any discipline to ensure uniqueness of the names. I might be able to convince them to use a namespace beginning with X-.  If this document were published as an RFC they would insist on not using a namespace beginning with X-.

I don't think it's at all appropriate for this document to retroactively change the behavior of every protocol now using X-.  The consequences of using unregistered or poorly designed extensions are not the same for all protocols.

I do think that maybe the "we won't ever standardize X-" rule is poorly stated.  I'm okay with standardizing a keyword that begins with X- if the facility associated with the keyword is found to be generally useful and if, in general, it seems to be used consistently in the wild.   Really we can already do that.   A community consensus action can always override another community consensus action.

But unilaterally declaring X- harmful, IMO, goes too far.

Keith

On Oct 19, 2010, at 2:23 PM, Peter Saint-Andre wrote:

> I finally got around to updating this one. It's still incomplete, in the
> sense that it doesn't discuss recommendations or desired changes to
> behavior. However, I figured a revised I-D was in order because the
> issue came up recently on the HTTPBIS list -- see thread starting here:
> 
> http://lists.w3.org/Archives/Public/ietf-http-wg/2010OctDec/0105.html
> 
> -------- Original Message --------
> Subject: I-D Action:draft-saintandre-xdash-considered-harmful-01.txt
> Date: Tue, 19 Oct 2010 11:15:01 -0700 (PDT)
> From: [email-masked]
> Reply-To: [email-masked]
> To: [email-masked]
> 
> A New Internet-Draft is available from the on-line Internet-Drafts
> directories.
> 
> 	Title           : "X-" Considered Harmful
> 	Author(s)       : P. Saint-Andre
> 	Filename        : draft-saintandre-xdash-considered-harmful-01.txt
> 	Pages           : 6
> 	Date            : 2010-10-19
> 
> Many application protocols use named parameters to represent data
> (for example, header fields in Internet mail messages and HTTP
> requests).  Historically, protocol designers and implementers have
> often differentiated between "standard" and "experimental" parameters
> by prefixing experimental parameters with the string "X-".  This
> document argues that, on balance, the "X-" convention has more costs
> than benefits.
> 
> A URL for this Internet-Draft is:
> http://www.ietf.org/internet-drafts/draft-saintandre-xdash-considered-harmful-01.txt
> 
> Internet-Drafts are also available by anonymous FTP at:
> ftp://ftp.ietf.org/internet-drafts/
> 
> Below is the data which will enable a MIME compliant mail reader
> implementation to automatically retrieve the ASCII version of the
> Internet-Draft.
> 
> <draft-saintandre-xdash-considered-harmful-01.txt><Attached Message Part.txt>_______________________________________________

---

From: Ted Hardie <[email-masked]>
Date: Sun, 14 Nov 2010 11:21:01 +0800

> I am currently working on a project where one of the vendors insists on using URNs to name things that don't have registered namespaces, and without establishing any discipline to ensure uniqueness…

RFC 3406 actually discusses both x- URNs and informal namespaces.  See
http://tools.ietf.org/html/rfc3406#section-3.1 .  Note that informal namespaces
are very rare (I can see only RFC-6050-to-be in the registry).  Whether x-
namespaces are more common or not is hard to say.  I have never seen one in
the wild.

regards,

Ted